Index: trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_flt_jki.F90	(revision 508)
@@ -25,4 +25,5 @@
    USE solfet          ! FETI solver
    USE solsor_e        ! Successive Over-relaxation solver with MPP optimization
+   USE solver
    USE obc_oce         ! Lateral open boundary condition
    USE obcdyn          ! ocean open boundary condition (obc_dyn routines)
@@ -35,4 +36,6 @@
    USE solmat          ! matrix construction for elliptic solvers
    USE agrif_opa_interp
+   USE restart         ! only for lrst_oce
+   USE iom
 
    IMPLICIT NONE
@@ -112,7 +115,14 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~~~  (free surface constant volume, autotasking case)'
 
-         ! set to zero free surface specific arrays 
-         spgu(:,:) = 0.e0      ! surface pressure gradient (i-direction)
-         spgv(:,:) = 0.e0      ! surface pressure gradient (j-direction)
+         ! set to zero free surface specific arrays
+         spgu(:,:) = 0.e0                     ! surface pressure gradient (i-direction)
+         
+         spgv(:,:) = 0.e0                     ! surface pressure gradient (j-direction)
+         
+         CALL solver_init( nit000 )           ! Elliptic solver initialisation
+
+         ! read filtered free surface arrays in restart file
+         CALL flt_rst( nit000, 'READ' )       ! read or initialize the following fields:
+         !                                    ! gcx, gcxb, sshb, sshn
       ENDIF
 
@@ -354,4 +364,8 @@
       CALL lbc_lnk( sshn, 'T', 1. )
 
+      ! write filtered free surface arrays in restart file
+      ! --------------------------------------------------
+      IF( lrst_oce ) CALL flt_rst( kt, 'WRITE' )
+
       IF(ln_ctl) THEN         ! print sum trends (used for debugging)
          CALL prt_ctl( tab3d_1=ua  , clinfo1=' spg  - Ua : ', mask1=umask,   &
@@ -362,4 +376,43 @@
    END SUBROUTINE dyn_spg_flt_jki
 
+   SUBROUTINE flt_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE ts_rst  ***
+     !!
+     !! ** Purpose : Read or write filtered free surface arrays in restart file
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+     !!----------------------------------------------------------------------
+
+     IF( TRIM(cdrw) == 'READ' ) THEN
+        IF( iom_varid( numror, 'gcx' ) > 0 ) THEN
+! Caution : extra-hallow
+! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+           CALL iom_get( numror, jpdom_local, 'gcx' , gcx (1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'gcxb', gcxb(1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'sshb', sshb(:,:)         )
+           CALL iom_get( numror, jpdom_local, 'sshn', sshn(:,:)         )
+           IF( neuler == 0 ) THEN
+              sshb(:,:) = sshn(:,:)
+              gcxb(:,:) = gcx (:,:)
+           ENDIF
+        ELSE
+           gcx (:,:) = 0.e0
+           gcxb(:,:) = 0.e0
+           sshb(:,:) = 0.e0
+           sshn(:,:) = 0.e0
+        ENDIF
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+! Caution : extra-hallow
+! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+        CALL iom_rstput( kt, nitrst, numrow, 'gcx' , gcx( 1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'gcxb', gcxb(1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'sshb', sshb(:,:)         )
+        CALL iom_rstput( kt, nitrst, numrow, 'sshn', sshn(:,:)         )
+     ENDIF
+     !
+   END SUBROUTINE flt_rst
+
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/DYN/dynspg_rl.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_rl.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_rl.F90	(revision 508)
@@ -4,4 +4,17 @@
    !! Ocean dynamics:  surface pressure gradient trend
    !!======================================================================
+   !! History :  7.0  !  96-05  (G. Madec, M. Imbard, M. Guyon)  rewitting in 1
+   !!                           routine, without pointers, and with the same matrix
+   !!                           for sor and pcg, mpp exchange, and symmetric conditions
+   !!            " "  !  96-07  (A. Weaver)  Euler forward step
+   !!            " "  !  96-11  (A. Weaver)  correction to preconditioning:
+   !!            8.0  !  98-02  (M. Guyon)  FETI method
+   !!            " "  !  97-09  (J.-M. Molines)  Open boundaries
+   !!            8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!                 !  02-11  (C. Talandier, A-M Treguier) Open boundaries
+   !!            9.0  !  04-08  (C. Talandier)  New trends organization
+   !!            " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!            " "  !  06-07  (S. Masson)  distributed restart using iom
+   !!---------------------------------------------------------------------
 #if   defined key_dynspg_rl   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -10,6 +23,6 @@
    !!   dyn_spg_rl   : update the momentum trend with the surface pressure
    !!                  for the rigid-lid case.
-   !!----------------------------------------------------------------------
-   !! * Modules used
+   !!   rl_rst       : read/write the rigid-lid restart fields in the ocean restart file
+   !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
@@ -19,4 +32,5 @@
    USE zdf_oce         ! ocean vertical physics
    USE sol_oce         ! ocean elliptic solver
+   USE solver          ! solver initialization
    USE solpcg          ! preconditionned conjugate gradient solver
    USE solsor          ! Successive Over-relaxation solver
@@ -28,9 +42,10 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
+   USE iom
+   USE restart         ! only for lrst_oce
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
    PUBLIC dyn_spg_rl   ! called by step.F90
 
@@ -42,5 +57,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -76,26 +91,8 @@
       !! ** Action : - Update (ua,va) with the surf. pressure gradient trend
       !!
-      !! References :
-      !!      Madec et al. 1988, ocean modelling, issue 78, 1-6.
-      !!
-      !! History :
-      !!        !  96-05  (G. Madec, M. Imbard, M. Guyon)  rewitting in 1
-      !!                  routine, without pointers, and with the same matrix
-      !!                  for sor and pcg, mpp exchange, and symmetric conditions
-      !!        !  96-07  (A. Weaver)  Euler forward step
-      !!        !  96-11  (A. Weaver)  correction to preconditioning:
-      !!        !  98-02  (M. Guyon)  FETI method
-      !!        !  98-05  (G. Roullet)  free surface
-      !!        !  97-09  (J.-M. Molines)  Open boundaries
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!        !  02-11  (C. Talandier, A-M Treguier) Open boundaries
-      !!   9.0  !  04-08  (C. Talandier)  New trends organization
-      !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
+      !! References : Madec et al. 1988, ocean modelling, issue 78, 1-6.
       !!---------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in  ) ::   kt       ! ocean time-step index
-      INTEGER, INTENT( out ) ::   kindic   ! solver flag, take a negative value
-      !                                    ! when the solver doesnot converge
-      !! * Local declarations
+      INTEGER, INTENT( out ) ::   kindic   ! solver flag (<0 when the solver does not converge)
       INTEGER ::   ji, jj, jk    ! dummy loop indices
       REAL(wp) ::  zbsfa, zgcx, z2dt
@@ -114,32 +111,23 @@
 
          ! set to zero rigid-lid specific arrays
-         spgu(:,:) = 0.e0      ! surface pressure gradient (i-direction) 
-         spgv(:,:) = 0.e0      ! surface pressure gradient (j-direction)
-      ENDIF
-
-      ! 0. Initializations:
-      ! -------------------
-# if defined key_obc
-      ! space index on boundary arrays
-      ib = 1
-      ibm = 2
-      ibm2 = 3
-      ! time index on boundary arrays
-      it = 1
-      itm = 2
-      itm2 = 3
-# endif
-
+         spgu(:,:) = 0.e0                   ! surface pressure gradient (i-direction) 
+         spgv(:,:) = 0.e0                   ! surface pressure gradient (j-direction)
+
+         CALL solver_init( nit000 )         ! Elliptic solver initialisation
+
+         ! read rigid lid arrays in restart file
+         CALL rl_rst( nit000, 'READ' )      ! read or initialize the following fields:
+         !                                  ! gcx, gcxb, bsfb, bsfn, bsfd
+      ENDIF
+
+      !  Vertically averaged momentum trend
+      ! ------------------------------------
       !                                                ! ===============
       DO jj = 2, jpjm1                                 !  Vertical slab
          !                                             ! ===============
-
-         ! 1. Vertically averaged momentum trend
-         ! -------------------------------------
-         ! initialization to zero
-         spgu(:,jj) = 0.
+         
+         spgu(:,jj) = 0.                          ! initialization to zero
          spgv(:,jj) = 0.
-         ! vertical sum
-         DO jk = 1, jpk
+         DO jk = 1, jpk                           ! vertical sum
             DO ji = 2, jpim1
                spgu(ji,jj) = spgu(ji,jj) + ua(ji,jj,jk) * fse3u(ji,jj,jk) * umask(ji,jj,jk)
@@ -147,6 +135,5 @@
             END DO 
          END DO 
-         ! divide by the depth
-         spgu(:,jj) = spgu(:,jj) * hur(:,jj)
+         spgu(:,jj) = spgu(:,jj) * hur(:,jj)      ! divide by the depth 
          spgv(:,jj) = spgv(:,jj) * hvr(:,jj)
 
@@ -155,27 +142,20 @@
       !                                                ! ===============
 
-      !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-
       ! Boundary conditions on (spgu,spgv)
       CALL lbc_lnk( spgu, 'U', -1. )
       CALL lbc_lnk( spgv, 'V', -1. )
 
-      !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
-
-      ! 2. Barotropic streamfunction trend (bsfd)
+      !  Barotropic streamfunction trend (bsfd)
       ! ----------------------------------
-
-      ! Curl of the vertically averaged velocity
-      DO jj = 2, jpjm1
+      DO jj = 2, jpjm1                            ! Curl of the vertically averaged velocity 
          DO ji = 2, jpim1
             gcb(ji,jj) = -gcdprc(ji,jj)   &
-                       *(  ( e2v(ji+1,jj  )*spgv(ji+1,jj  ) - e2v(ji,jj)*spgv(ji,jj) )   &
-                          -( e1u(ji  ,jj+1)*spgu(ji  ,jj+1) - e1u(ji,jj)*spgu(ji,jj) )   ) 
+               &       *(  ( e2v(ji+1,jj  )*spgv(ji+1,jj  ) - e2v(ji,jj)*spgv(ji,jj) )   &
+               &          -( e1u(ji  ,jj+1)*spgu(ji  ,jj+1) - e1u(ji,jj)*spgu(ji,jj) )   ) 
          END DO
       END DO
 
 # if defined key_obc
-      ! Open boundary contribution
-      DO jj = 2, jpjm1
+      DO jj = 2, jpjm1                            ! Open boundary contribution 
          DO ji = 2, jpim1
            gcb(ji,jj) = gcb(ji,jj) - gcdprc(ji,jj) * gcbob(ji,jj)
@@ -198,6 +178,4 @@
       ! applied the lateral boundary conditions
       IF( nsolv == 4)   CALL lbc_lnk_e( gcb, c_solver_pt, 1. )   
-
-      !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
 
       ! Relative precision (computation on one processor)
@@ -234,16 +212,11 @@
       ENDIF
 
-
       ! bsf trend update
       ! ----------------
-
       bsfd(1:nlci,1:nlcj) = gcx(1:nlci,1:nlcj)
-
       
       ! update bsf trend with islands trend
       ! -----------------------------------
-
       IF( lk_isl )   CALL isl_dyn_spg         ! update bsfd
-
 
 # if defined key_obc
@@ -337,5 +310,4 @@
       ! 4. Barotropic stream function and array swap
       ! --------------------------------------------
-
       ! Leap-frog time scheme, time filter and array swap
       IF( neuler == 0 .AND. kt == nit000 ) THEN
@@ -362,4 +334,11 @@
 
 # if defined key_obc
+      ib   = 1      ! space index on boundary arrays
+      ibm  = 2
+      ibm2 = 3
+      it   = 1      ! time index on boundary arrays
+      itm  = 2
+      itm2 = 3
+
       ! Swap of boundary arrays
       IF( lp_obc_east ) THEN
@@ -499,12 +478,8 @@
       ENDIF
 # endif
-      !
-      !,,,,,,,,,,,,,,,,,,,,,,,,,,,,,synchro,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
       
       !  add the surface pressure trend to the general trend
       ! -----------------------------------------------------
-      
       DO jj = 2, jpjm1
-
          ! update the surface pressure gradient with the barotropic trend
          DO ji = 2, jpim1
@@ -519,8 +494,53 @@
             END DO
          END DO
-
-      END DO
+      END DO
+
+      ! write rigid lid arrays in restart file
+      ! --------------------------------------
+      IF( lrst_oce ) CALL rl_rst( kt, 'WRITE' )
 
    END SUBROUTINE dyn_spg_rl
+
+
+   SUBROUTINE rl_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE rl_rst  ***
+     !!
+     !! ** Purpose : Read or write rigid-lid arrays in ocean restart file
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+     !!----------------------------------------------------------------------
+     !
+     IF( TRIM(cdrw) == 'READ' ) THEN
+        IF( iom_varid( numror, 'gcx' ) > 0 ) THEN
+     ! Caution : extra-hallow
+     ! gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+           CALL iom_get( numror, jpdom_local, 'gcx' , gcx (1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'gcxb', gcxb(1:jpi,1:jpj) )
+           CALL iom_get( numror, jpdom_local, 'bsfb', bsfb(:,:)         )
+           CALL iom_get( numror, jpdom_local, 'bsfn', bsfn(:,:)         )
+           CALL iom_get( numror, jpdom_local, 'bsfd', bsfd(:,:)         )
+           IF( neuler == 0 ) THEN
+              gcxb(:,:) = gcx (:,:)
+              bsfb(:,:) = bsfn(:,:)
+           ENDIF
+        ELSE
+           gcx (:,:) = 0.e0
+           gcxb(:,:) = 0.e0
+           bsfb(:,:) = 0.e0
+           bsfn(:,:) = 0.e0
+           bsfd(:,:) = 0.e0
+        ENDIF
+     ELSEIF(  TRIM(cdrw) == 'WRITE' ) THEN
+        ! Caution : extra-hallow, gcx and gcxb are defined as: DIMENSION(1-jpr2di:jpi+jpr2di,1-jpr2dj:jpj+jpr2dj)
+        CALL iom_rstput( kt, nitrst, numrow, 'gcx' , gcx (1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'gcxb', gcxb(1:jpi,1:jpj) )
+        CALL iom_rstput( kt, nitrst, numrow, 'bsfb', bsfb(:,:)         )
+        CALL iom_rstput( kt, nitrst, numrow, 'bsfn', bsfn(:,:)         )
+        CALL iom_rstput( kt, nitrst, numrow, 'bsfd', bsfd(:,:)         )
+     ENDIF
+     !
+   END SUBROUTINE rl_rst
 
 #else
Index: trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 508)
@@ -4,4 +4,8 @@
    !! Ocean dynamics:  surface pressure gradient trend
    !!======================================================================
+   !! History :   9.0  !  04-12  (L. Bessieres, G. Madec)  Original code
+   !!             " "  !  05-11  (V. Garnier, G. Madec)  optimization
+   !!             9.0  !  06-08  (S. Masson)  distributed restart using iom
+   !!---------------------------------------------------------------------
 #if ( defined key_dynspg_ts && ! defined key_mpp_omp ) ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -9,6 +13,8 @@
    !!   NOT 'key_mpp_omp'                          k-j-i loop (vector opt.)
    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    !!   dyn_spg_ts  : compute surface pressure gradient trend using a time-
    !!                 splitting scheme and add to the general trend 
+   !!   ts_rst      : read/write the time-splitting restart fields in the ocean restart file
    !!----------------------------------------------------------------------
    !! * Modules used
@@ -27,10 +33,15 @@
    USE dynspg_oce      ! surface pressure gradient variables
    USE in_out_manager  ! I/O manager
+   USE iom
+   USE restart         ! only for lrst_oce
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Accessibility
    PUBLIC dyn_spg_ts  ! routine called by step.F90
+
+   REAL(wp), DIMENSION(jpi,jpj) ::  ftnw, ftne,   &  ! triad of coriolis parameter
+      &                             ftsw, ftse       ! (only used with een vorticity scheme)
+
 
    !! * Substitutions
@@ -74,12 +85,6 @@
       !! ** Action : - Update (ua,va) with the surf. pressure gradient trend
       !!
-      !! References :
-      !!   Griffies et al., (2003): A technical guide to MOM4. NOAA/GFDL
-      !!
-      !! History :
-      !!   9.0  !  04-12  (L. Bessieres, G. Madec)  Original code
-      !!        !  05-11  (V. Garnier, G. Madec)  optimization
+      !! References : Griffies et al., (2003): A technical guide to MOM4. NOAA/GFDL
       !!---------------------------------------------------------------------
-      !! * Arguments
       INTEGER, INTENT( in )  ::   kt           ! ocean time-step index
 
@@ -97,6 +102,4 @@
          zsshb_e, zub_e, zvb_e,             &  !     "        "
          zun_e, zvn_e                          !     "        "
-      REAL(wp), DIMENSION(jpi,jpj),SAVE ::  &
-         ztnw, ztne, ztsw, ztse
       !!----------------------------------------------------------------------
 
@@ -109,5 +112,5 @@
 
       IF( kt == nit000 ) THEN
-
+         !
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'dyn_spg_ts : surface pressure gradient trend'
@@ -115,25 +118,7 @@
          IF(lwp) WRITE(numout,*) ' Number of sub cycle in 1 time-step (2 rdt) : icycle = ', FLOOR( 2*rdt/rdtbt )
 
-         IF( .NOT. ln_rstart ) THEN
-            ! initialize barotropic specific arrays
-            sshb_b(:,:) = sshb(:,:)
-            sshn_b(:,:) = sshn(:,:)
-            un_b(:,:)   = 0.e0
-            vn_b(:,:)   = 0.e0
-            ! vertical sum
-            IF( lk_vopt_loop ) THEN          ! vector opt., forced unroll
-               DO jk = 1, jpkm1
-                  DO ji = 1, jpij
-                     un_b(ji,1) = un_b(ji,1) + fse3u(ji,1,jk) * un(ji,1,jk)
-                     vn_b(ji,1) = vn_b(ji,1) + fse3v(ji,1,jk) * vn(ji,1,jk)
-                  END DO
-               END DO
-            ELSE                             ! No  vector opt.
-               DO jk = 1, jpkm1
-                  un_b(:,:) = un_b(:,:) + fse3u(:,:,jk) * un(:,:,jk)
-                  vn_b(:,:) = vn_b(:,:) + fse3v(:,:,jk) * vn(:,:,jk)
-               END DO
-            ENDIF
-         ENDIF
+         CALL ts_rst( nit000, 'READ' )   ! read or initialize the following fields:
+         !                               ! sshb, sshn, sshb_b, sshn_b, un_b, vn_b
+
          ssha_e(:,:) = sshn(:,:)
          ua_e(:,:)   = un_b(:,:)
@@ -141,17 +126,17 @@
 
          IF( ln_dynvor_een ) THEN
-            ztne(1,:) = 0.e0   ;   ztnw(1,:) = 0.e0   ;   ztse(1,:) = 0.e0   ;   ztsw(1,:) = 0.e0
+            ftne(1,:) = 0.e0   ;   ftnw(1,:) = 0.e0   ;   ftse(1,:) = 0.e0   ;   ftsw(1,:) = 0.e0
             DO jj = 2, jpj
                DO ji = fs_2, jpi   ! vector opt.
-                  ztne(ji,jj) = ( ff(ji-1,jj  ) + ff(ji  ,jj  ) + ff(ji  ,jj-1) ) / 3.
-                  ztnw(ji,jj) = ( ff(ji-1,jj-1) + ff(ji-1,jj  ) + ff(ji  ,jj  ) ) / 3.
-                  ztse(ji,jj) = ( ff(ji  ,jj  ) + ff(ji  ,jj-1) + ff(ji-1,jj-1) ) / 3.
-                  ztsw(ji,jj) = ( ff(ji  ,jj-1) + ff(ji-1,jj-1) + ff(ji-1,jj  ) ) / 3.
+                  ftne(ji,jj) = ( ff(ji-1,jj  ) + ff(ji  ,jj  ) + ff(ji  ,jj-1) ) / 3.
+                  ftnw(ji,jj) = ( ff(ji-1,jj-1) + ff(ji-1,jj  ) + ff(ji  ,jj  ) ) / 3.
+                  ftse(ji,jj) = ( ff(ji  ,jj  ) + ff(ji  ,jj-1) + ff(ji-1,jj-1) ) / 3.
+                  ftsw(ji,jj) = ( ff(ji  ,jj-1) + ff(ji-1,jj-1) + ff(ji-1,jj  ) ) / 3.
                END DO
             END DO
          ENDIF
-
+         !
       ENDIF
-    
+
       ! Local constant initialization
       ! --------------------------------
@@ -216,5 +201,5 @@
             END DO
          END DO
-
+         !
       ELSEIF ( ln_dynvor_ens ) THEN                    ! enstrophy conserving scheme
          DO jj = 2, jpjm1
@@ -228,5 +213,5 @@
             END DO
          END DO
-
+         !
       ELSEIF ( ln_dynvor_een ) THEN                    ! enstrophy and energy conserving scheme
          zfac25 = 0.25
@@ -241,5 +226,5 @@
             END DO
          END DO
-
+         !
       ENDIF
 
@@ -300,5 +285,4 @@
       DO jit = 1, icycle                                   !  sub-time-step loop  !
          !                                                 ! ==================== !
-
          z2dt_e = 2. * rdtbt
          IF ( jit == 1 )   z2dt_e = rdtbt
@@ -360,5 +344,5 @@
                END DO
             END DO
-
+            !
          ELSEIF ( ln_dynvor_ens ) THEN                    ! enstrophy conserving scheme
             DO jj = 2, jpjm1
@@ -379,5 +363,5 @@
                END DO
             END DO
-
+            !
          ELSEIF ( ln_dynvor_een ) THEN                    ! energy and enstrophy conserving scheme
             zfac25 = 0.25
@@ -397,4 +381,5 @@
                END DO
             END DO
+            ! 
          ENDIF
 
@@ -504,9 +489,72 @@
       END DO
 
-      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
-         CALL prt_ctl(tab2d_1=sshn, clinfo1=' ssh      : ', mask1=tmask)
+      ! write filtered free surface arrays in restart file
+      ! --------------------------------------------------
+      IF( lrst_oce )   CALL ts_rst( kt, 'WRITE' )
+
+      ! print sum trends (used for debugging)
+      IF( ln_ctl )     CALL prt_ctl( tab2d_1=sshn, clinfo1=' ssh      : ', mask1=tmask )
+      !
+   END SUBROUTINE dyn_spg_ts
+
+
+   SUBROUTINE ts_rst( kt, cdrw )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE ts_rst  ***
+      !!
+      !! ** Purpose : Read or write time-splitting arrays in restart file
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+      CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+      !
+      INTEGER ::  ji, jk        ! dummy loop indices
+      !!----------------------------------------------------------------------
+      !
+      IF( TRIM(cdrw) == 'READ' ) THEN
+         IF( iom_varid( numror, 'sshn' ) > 0 ) THEN
+            CALL iom_get( numror, jpdom_local, 'sshb'  , sshb(:,:)   )
+            CALL iom_get( numror, jpdom_local, 'sshn'  , sshn(:,:)   )
+            IF( neuler == 0 ) sshb(:,:) = sshn(:,:)
+         ELSE
+            sshb(:,:) = 0.e0
+            sshn(:,:) = 0.e0
+         ENDIF
+         IF( iom_varid( numror, 'sshn_b' ) > 0 ) THEN
+            CALL iom_get( numror, jpdom_local, 'sshb_b', sshb_b(:,:) )   ! free surface issued
+            CALL iom_get( numror, jpdom_local, 'sshn_b', sshn_b(:,:) )   ! from time-splitting loop
+            CALL iom_get( numror, jpdom_local, 'un_b'  , un_b  (:,:) )   ! horizontal transports issued
+            CALL iom_get( numror, jpdom_local, 'vn_b'  , vn_b  (:,:) )   ! from barotropic loop
+            IF( neuler == 0 ) sshb_b(:,:) = sshn_b(:,:)
+         ELSE
+            sshb_b(:,:) = sshb(:,:)
+            sshn_b(:,:) = sshn(:,:)
+            un_b  (:,:) = 0.e0
+            vn_b  (:,:) = 0.e0
+            ! vertical sum
+            IF( lk_vopt_loop ) THEN          ! vector opt., forced unroll
+               DO jk = 1, jpkm1
+                  DO ji = 1, jpij
+                     un_b(ji,1) = un_b(ji,1) + fse3u(ji,1,jk) * un(ji,1,jk)
+                     vn_b(ji,1) = vn_b(ji,1) + fse3v(ji,1,jk) * vn(ji,1,jk)
+                  END DO
+               END DO
+            ELSE                             ! No  vector opt.
+               DO jk = 1, jpkm1
+                  un_b(:,:) = un_b(:,:) + fse3u(:,:,jk) * un(:,:,jk)
+                  vn_b(:,:) = vn_b(:,:) + fse3v(:,:,jk) * vn(:,:,jk)
+               END DO
+            ENDIF
+         ENDIF
+      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+         CALL iom_rstput( kt, nitrst, numrow, 'sshb'  , sshb  (:,:) )
+         CALL iom_rstput( kt, nitrst, numrow, 'sshn'  , sshn  (:,:) )
+         CALL iom_rstput( kt, nitrst, numrow, 'sshb_b', sshb_b(:,:) )   ! free surface issued
+         CALL iom_rstput( kt, nitrst, numrow, 'sshn_b', sshn_b(:,:) )   ! from barotropic loop
+         CALL iom_rstput( kt, nitrst, numrow, 'un_b'  , un_b  (:,:) )   ! horizontal transports issued
+         CALL iom_rstput( kt, nitrst, numrow, 'vn_b'  , vn_b  (:,:) )   ! from barotropic loop
       ENDIF
-      
-   END SUBROUTINE dyn_spg_ts
+      !
+   END SUBROUTINE ts_rst
+
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 508)
@@ -4,4 +4,16 @@
    !! solver       : construction of the matrix 
    !!======================================================================
+   !! History :   1.0  !  88-04  (G. Madec)  Original code
+   !!                  !  93-03  (M. Guyon)  symetrical conditions
+   !!                  !  93-06  (M. Guyon)  suppress pointers
+   !!                  !  96-05  (G. Madec)  merge sor and pcg formulations
+   !!                  !  96-11  (A. Weaver)  correction to preconditioning
+   !!                  !  98-02  (M. Guyon)  FETI method
+   !!             8.5  !  02-08  (G. Madec)  F90: Free form
+   !!                  !  02-11  (C. Talandier, A-M. Treguier) Free surface & Open boundaries
+   !!             9.0  !  05-09  (R. Benshila)  add sol_exd for extra outer halo
+   !!             9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             9.0  !  06-07  (S. Masson)  distributed restart using iom
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -29,5 +41,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -55,16 +67,4 @@
       !!              - gcdmat : preconditioning matrix (diagonal elements)
       !!              - gcdprc : inverse of the preconditioning matrix
-      !!
-      !! History :
-      !!   1.0  !  88-04  (G. Madec)  Original code
-      !!        !  91-11  (G. Madec)
-      !!        !  93-03  (M. Guyon)  symetrical conditions
-      !!        !  93-06  (M. Guyon)  suppress pointers
-      !!        !  96-05  (G. Madec)  merge sor and pcg formulations
-      !!        !  96-11  (A. Weaver)  correction to preconditioning
-      !!        !  98-02  (M. Guyon)  FETI method
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form
-      !!        !  02-11  (C. Talandier, A-M. Treguier) Free surface & Open boundaries
-      !!   9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
       !!----------------------------------------------------------------------
       !! * Arguments
